<?php
# masta copyright 2001 - 2002
ob_start();
/* FUNKTIONEN */

class Template{
	function Template($datei, $temp_anfang, $temp_ende, $replace_array){
		$this->datei = $datei;
		$this->temp_anfang = $temp_anfang;
		$this->temp_ende = $temp_ende;
		$this->replace_array = $replace_array;
	}
	function getTemplate(){
		$template = join("", file($this->datei));
		preg_match("/".str_replace("[", "\[", str_replace("]", "\]", $this->temp_anfang))."(.*)".str_replace("[", "\[", str_replace("]", "\]", $this->temp_ende))."/msiU", $template, $return);
		return $return[1];
	}
	function getStrTemplate(){
		$return = $this->getTemplate();
		foreach($this->replace_array as $key => $value){
			$return = str_replace($key, $value, $return);
		}
		return $return;
	}
}


function mailcheck($mailadresse) {
	if (eregi("^[a-z0-9]+([-_\.]?[a-z0-9])+@[a-z0-9]+([-_\.]?[a-z0-9])+\.[a-z]{2,4}", $mailadresse)) {
	return TRUE;}
	elseif($mailadresse == ""){return FALSE;}
	else{return FALSE;}
}

function icqcheck($uin) {
	if (preg_match("=^[0-9]+$=i",$uin)){
	return TRUE;}
	elseif($uin == ""){
	return TRUE;}
	else {return FALSE;}
}

function hpcheck($hpadresse){
	if ($hpadresse != "" && $hpadresse != "http://"){
		if(!strchr($hpadresse, "http://") || !strchr($hpadresse, ".")){
		return FALSE;}
		else{ return TRUE; }
	}
	else{ return TRUE; }
}

function smilies($text)
{
$array = array(	":bluescreen:" => "bluescreen.gif",
		":(" => "frown.gif",
		":schuechtern:" => "schuechtern.gif",
		":cool:" => "cool.gif",
		":alien:" => "alien.gif",
		":)" => "smile.gif",
		":D" => "biggrin.gif",
		":rofl:" => "rofl.gif",
		":furz:" => "furz.gif",
		":lol:" => "lol.gif",
		":mad:" => "mad.gif",
		":chainsaw:" => "doom.gif",
		";)" => "wink.gif",
		":schlaf:" => "sleep.gif",
		":prost:" => "prost.gif",
		":p" => "tongue.gif",
		":o" => "redface.gif",
		":kotz:" => "kotz.gif",
		":konfus:" => "konfus.gif",
		":heul:" => "heul.gif",
		":schande:" => "schande.gif",
		":fotzen:" => "hammer.gif",
		":ficken:" => "ficken.gif",
		":???:" => "confused.gif",
		":camp:" => "camper.gif",
		":granate:" => "grenade.gif",
		":target:" => "target1.gif",
		":love:" => "love.gif",
		":heiligenschein:" => "heiligenschein.gif",
		":instagib:" => "instagib.gif",
		":sniper:" => "sniper.gif",
		":rocket:" => "rocket.gif",
		":asmd:" => "asmd.gif",
		":rail:" => "rail.gif",
		":headshot:" => "headshot.gif");
        	foreach($array as $key => $value){
               		$text = str_replace($key, '<img src="smileys/'.$value.'" border="0">', $text);
		}
	return $text;
}

function gbcode($text)
{

//bold text
$text=preg_replace("/b\[(.*)\]b/iUms","<b>\\1</b>",$text);

//kursiv text
$text=preg_replace("/i\[(.*)\]i/iUms","<i>\\1</i>",$text);

//underlined text
$text=preg_replace("/u\[(.*)\]u/iUms","<u>\\1</u>",$text);

//strike text
$text=preg_replace("/-\[(.*)\]-/iUms","<strike>\\1</strike>",$text);

//www. to http://www.
$text=preg_replace("/(^| )www\./i","http://www.", $text);

//email link
$text=preg_replace("/\[email\](.*)\[\/email\]/msiU", "<a href=\"mailto:\\1\">\\1</a>", $text); 

//url link
$text=preg_replace("/\[url\](.*)\[\/url\]/iUms","<a target=\"_blank\" href=\"\\1\">\\1</a>",$text);

//url link mit beschreibung
$text=preg_replace("/\[url=(.*)\](.*)\[\/url\]/siU","<a href=\"\\1\" target=\"_blank\">\\2</a>",$text);

//code ausrichtung
$text=preg_replace("/\[code\](.*)\[\/code\]/msiU", "<blockquote><pre><smallfont>code:<hr>\\1<hr></blockquote></pre></smallfont>", $text); 

//quote ausrichtung
$text=preg_replace("/\[quote\](.*)\[\/quote\]/msiU", "<blockquote><smallfont>quote:<hr>\\1<hr></blockquote></smallfont>", $text); 

//pic anzeigen
$text=preg_replace("/\[img\](.*)\[\/img\]/iUms","<center><img src=\"\\1\" alt=\"bild\" border=\"0\"></center>",$text);

return $text;
}

/* FUNKTIONEN ENDE */

//Config Datei includen
include("config.inc.php");

$template = join("", file($template_name));

// Head auslesen und ausgeben
$temp = new Template("template.html", "[head_anfang]", "[head_ende]", array("[titel]" => $titel));
echo $temp->getStrTemplate();

// Foo auslesen
$temp = new Template("template.html", "[foo_anfang]", "[foo_ende]", array("[titel]" => $titel));
$foo = $temp->getStrTemplate();

// Eingabe auslesen
$temp = new Template("template.html", "[eingabe_start]", "[eingabe_ende]", NULL);
$eingabe = $temp->getTemplate();

// Admin Forumlar auslesen
$temp = new Template("template.html", "[admin_form_start]", "[admin_form_ende]", NULL);
$admin_form = $temp->getTemplate();

// Fehler auslesen
$temp = new Template("template.html", "[fehler_start]", "[fehler_ende]", NULL);
$fehler = $temp->getTemplate();

// Admin Fehler auslesen
$temp = new Template("template.html", "[fehler_admin_start]", "[fehler_admin_ende]", NULL);
$fehler_admin = $temp->getTemplate();

// Danke auslesen
$temp = new Template("template.html", "[danke_start]", "[danke_ende]", NULL);
$danke = $temp->getTemplate();

// Admin Danke auslesen
$temp = new Template("template.html", "[danke_admin_start]", "[danke_admin_ende]", NULL);
$danke_admin = $temp->getTemplate();

/*#####################################################################################*/

//$ip=getenv("HTTP_X_FORWARDED_FOR");
$ip=getenv("REMOTE_ADDR");

if(!isset($goto)){ $goto="view"; }

if($goto=="submit"){

$res = array_reverse(file($file));
$row = explode("|@@--@@|", $res[0]);
$letzte_ip = $row[6];

if( $letzte_ip == $ip || (trim($HTTP_POST_VARS[name])=="") || (!isset($HTTP_POST_VARS[name])) || (trim($HTTP_POST_VARS[text])=="") || (!isset($HTTP_POST_VARS[text])) || (!mailcheck(trim($HTTP_POST_VARS[email]))) || (!icqcheck(trim($HTTP_POST_VARS[icq]))) || (!hpcheck(trim($HTTP_POST_VARS[homepage]))) ){
if(trim($HTTP_POST_VARS[name]) == "" || !isset($HTTP_POST_VARS[name])){ $error = $error.$message[name]."<br>"; }
if(!mailcheck(trim($HTTP_POST_VARS[email]))){ $error = $error.$message[email]."<br>"; }
if(!icqcheck(trim($HTTP_POST_VARS[icq]))){ $error = $error.$message[icq]."<br>"; }
if(!hpcheck(trim($HTTP_POST_VARS[homepage]))){ $error = $error.$message[homepage]."<br>"; }
if(trim($HTTP_POST_VARS[text]) == "" || !isset($HTTP_POST_VARS[text])){ $error = $error.$message[text]."<br>"; }
if($letzte_ip == $ip){ $error = $error.$message[spam]."<br>"; }
$fehler = str_replace("[error]", $error, str_replace("[back]", '<a href="'.$PHP_SELF.'">'.$message[back].'</a>', $fehler));
echo $fehler;}
else{

$time = time();
$fp = fopen($file, "a");
$add = $HTTP_POST_VARS[name]."|@@--@@|".$HTTP_POST_VARS[email]."|@@--@@|".str_replace("\n", "<br>", smilies(gbcode(htmlspecialchars($HTTP_POST_VARS[text]))))."|@@--@@|".$time."|@@--@@|".$HTTP_POST_VARS[homepage]."|@@--@@|".$HTTP_POST_VARS[icq]."|@@--@@|".$ip."\n";
fputs($fp, $add);
fclose($fp);
$danke = str_replace("[back]", '<a href="'.$PHP_SELF.'">'.$message[back].'</a>', $danke);
echo $danke;}
}

elseif($goto=="view"){
$eingabe = str_replace("[PHP_SELF]", $PHP_SELF, str_replace("[admin]", '[ <a href="'.$PHP_SELF.'?goto=admin">admin</a> ]', $eingabe));
echo $eingabe."<br><br>";
$res = array_reverse(file($file));
$eintraege = count($res);
$x = $eintraege-1;
if($eintraege == 0){ echo '<br><br><div align="center"><font face="Verdana, Arial, Helvetica, sans-serif" size="2">Keine Eintraege vorhanden.</font></div>'; }
else{
for($i=0; $i<count($res); $i++){
$row = explode("|@@--@@|", $res[$i]);
$name = $row[0]; $email = $row[1]; $text = $row[2]; $datum = $row[3]; $homepage = $row[4]; $icq = $row[5]; $ip = $row[6];
// Ausgabe auslesen
preg_match("/\[ausgabe_start\](.*)\[ausgabe_ende\]/msiU", $template, $ausgabe);
$ausgabe = preg_replace("/\[ausgabe_start\](.*)\[ausgabe_ende\]/msiU", "\\1", $ausgabe[0]);
if(!isset($HTTP_COOKIE_VARS[admin_user]) || $HTTP_COOKIE_VARS[admin_user] != $admin_user || !isset($HTTP_COOKIE_VARS[admin_pass]) || $HTTP_COOKIE_VARS[admin_pass] != $admin_pass){
$ausgabe = str_replace("[admin]", "", $ausgabe);}
else{
$ausgabe = str_replace("[admin]", ' - <a href="'.$PHP_SELF.'?goto=admin_del&admin_del='.$x.'">del</a>', $ausgabe);
}	
$ausgabe = str_replace("[name]", $name, $ausgabe);
$zeit = $datum;
$datum = date("d.m - H:i", $zeit);
$ausgabe = str_replace("[datum]", $datum, $ausgabe);
$ausgabe = str_replace("[email]", $email, $ausgabe);
$ausgabe = str_replace("[text]", $text, $ausgabe);
if($homepage != ""){ $ausgabe = str_replace("[homepage]", '<a href="'.$homepage.'" target="_blank">klick</a>', $ausgabe); }
else{ $ausgabe = str_replace("[homepage]", "n/a", $ausgabe); }
if($icq != ""){ $ausgabe = str_replace("[icq_uin]", $icq, $ausgabe); }
else{ $ausgabe = str_replace("[icq_uin]", "n/a", $ausgabe); }
$ausgabe = str_replace("[id]", $eintraege, $ausgabe);
echo stripslashes($ausgabe)."<br>";
$eintraege--;
$x--;
}
}
}
elseif($goto=="admin"){
echo str_replace("[back]", '<a href="'.$PHP_SELF.'">'.$message[back].'</a>', str_replace("[PHP_SELF]", $PHP_SELF, $admin_form));
}

elseif($goto=="login"){

if($HTTP_POST_VARS[admin_user] != $admin_user || $HTTP_POST_VARS[admin_pass] != $admin_pass){
if($HTTP_POST_VARS[admin_user] != $admin_user){ $login_error=$login_error.$message[username_false]."<br>"; }
if($HTTP_POST_VARS[admin_pass] != $admin_pass){ $login_error=$login_error.$message[passwort_false]."<br>"; }
echo str_replace("[back]", '<a href="'.$PHP_SELF.'">'.$message[back].'</a>', str_replace("[error]", $login_error, $fehler_admin));
}

else{
@setcookie("admin_user", $HTTP_POST_VARS[admin_user], time()+(3600*24*365));
@setcookie("admin_pass", $HTTP_POST_VARS[admin_pass], time()+(3600*24*365));
header("Location: ".$PHP_SELF);
}
}

elseif($goto=="admin_del"){
if($HTTP_COOKIE_VARS[admin_user] != $admin_user || $HTTP_COOKIE_VARS[admin_pass] != $admin_pass){
if($HTTP_COOKIE_VARS[admin_user] != $admin_user){ $login_error=$login_error.$message[username_false]."<br>"; }
if($HTTP_COOKIE_VARS[admin_pass] != $admin_pass){ $login_error=$login_error.$message[passwort_false]."<br>"; }
echo str_replace("[back]", '<a href="'.$PHP_SELF.'">'.$message[back].'</a>', str_replace("[error]", $login_error, $fehler_admin));}
else{

$zeile=file($file);
if(!$zeile[$admin_del]){ echo str_replace("[back]", '<a href="'.$PHP_SELF.'">'.$message[back].'</a>', str_replace("[error]", $message[id_missmatch], $fehler_admin)); }
else{
$eintrag = explode("@@--@@|", $zeile[$admin_del]);
$eintrag = $eintrag[2];
$zeile[$admin_del]="";
$string=join("", $zeile);
$fp=fopen("daten.txt", w);
fwrite($fp,$string);
fclose($fp);

$text = $eintrag;
echo str_replace("[back]", '<a href="'.$PHP_SELF.'">'.$message[back].'</a>', str_replace("[text]", $text, $danke_admin));
}
}
}

echo $foo;

?>